<?php
/**
 * 升级运行文件
 * @作者 qinggan <admin@phpok.com>
 * @主页 http://www.phpok.com
 * @授权 http://www.phpok.com/lgpl.html 开源授权协议：GNU Lesser General Public License
 * @时间 2021年12月28日
**/

/**
 * 安全限制，防止直接访问
**/
if(!defined("PHPOK_SET")){
	exit("<h1>Access Denied</h1>");
}



/**
 * 字段增加一个父级ID属性
**/
$fields = $this->db->list_fields('fields');
if(!in_array('parent_id',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."fields` ADD `parent_id` INT UNSIGNED NOT NULL DEFAULT '0' COMMENT '父级ID（用于实现横排）'";
	$this->db->query($sql);
}

/**
 * 统计明细增加首次进入时间和最后进入时间
**/
$fields = $this->db->list_fields('stat_info');
if(!in_array('firstlogin',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."stat_info` ADD `firstlogin` INT UNSIGNED NOT NULL DEFAULT '0' COMMENT '首次访问时间'";
	$this->db->query($sql);
}

if(!in_array('lastlogin',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."stat_info` ADD `lastlogin` INT UNSIGNED NOT NULL DEFAULT '0' COMMENT '最后访问时间'";
	$this->db->query($sql);
}

/**
 * 增加库存
**/
$sql = "CREATE TABLE IF NOT EXISTS `".$this->db->prefix."stock` (`id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',`tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '主题ID',`attr` varchar(255) NOT NULL COMMENT '属性值，多个属性值用英文逗号隔开',`qty` int(10) NOT NULL DEFAULT '0' COMMENT '库存数量，仅支持整数',`cost` decimal(10,4) NOT NULL DEFAULT '0.0000' COMMENT '进货价',`market` decimal(10,4) NOT NULL DEFAULT '0.0000' COMMENT '市场价',`price` decimal(10,4) NOT NULL DEFAULT '0.0000' COMMENT '销售价',PRIMARY KEY (`id`),UNIQUE KEY `sku_id` (`tid`,`attr`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='库存表' AUTO_INCREMENT=1";
$this->db->query($sql);

/**
 * 删除已存在的表 list_stock
**/
$sql = "DROP TABLE IF EXISTS ".$this->db->prefix."list_stock";
$this->db->query($sql);

/**
 * 增加库存字段
**/
$fields = $this->db->list_fields('list_biz');
if(!in_array('qty',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."list_biz` ADD `qty` INT UNSIGNED NOT NULL DEFAULT '0' COMMENT '库存数量'";
	$this->db->query($sql);
}

/**
 * 增加批发价
**/
$sql = "CREATE TABLE IF NOT EXISTS `".$this->db->prefix."wholesale` (`id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',`tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '主题',`qty` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '数量',`price` decimal(10,4) unsigned NOT NULL DEFAULT '0.0000' COMMENT '价格',PRIMARY KEY (`id`),KEY `tid` (`tid`)) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='批发价格管理' AUTO_INCREMENT=1";
$this->db->query($sql);


/**
 * 增加已购统计
**/
$fields = $this->db->list_fields('order_product');
if(!in_array('price_total',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."order_product` ADD `price_total` DECIMAL( 10, 4 ) UNSIGNED NOT NULL DEFAULT '0' COMMENT '总价格'";
	$this->db->query($sql);
}
if(!in_array('discount',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."order_product` ADD `discount` DECIMAL( 10, 4 ) UNSIGNED NOT NULL DEFAULT '0' COMMENT '优惠价'";
	$this->db->query($sql);
}
if(!in_array('discount_note',$fields)){
	$sql = "ALTER TABLE `".$this->db->prefix."order_product` ADD `discount_note` VARCHAR( 255 ) NOT NULL COMMENT '优惠说明'";
	$this->db->query($sql);
}

/**
 * 内容日志
**/
$sql = "CREATE TABLE IF NOT EXISTS `".$this->db->prefix."log_content` (`id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',`tbl` varchar(255) NOT NULL COMMENT '表名（不含前缀）',`dateline` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '发布时间',`tid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '主题ID',`vtype` varchar(255) NOT NULL DEFAULT '' COMMENT '类型',`code` varchar(255) NOT NULL DEFAULT '' COMMENT '类型标识',`content1` text NOT NULL COMMENT '变更前的数据',`content2` text NOT NULL COMMENT '变更后的数据',PRIMARY KEY (`id`),KEY `tbl_tid` (`tbl`,`tid`)) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='内容变更记录' AUTO_INCREMENT=1";
$this->db->query($sql);